
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Request and response VCL objects &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="actions" href="vcl-actions.html" />
    <link rel="prev" title="Built in subroutines" href="vcl-built-in-subs.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="vcl-actions.html" title="actions"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="vcl-built-in-subs.html" title="Built in subroutines"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" accesskey="U">VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Request and response VCL objects</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="request-and-response-vcl-objects">
<h1>Request and response VCL objects<a class="headerlink" href="#request-and-response-vcl-objects" title="Permalink to this headline">¶</a></h1>
<p>In VCL, there several important objects that you need to be aware of. These
objects can be accessed and manipulated using VCL.</p>
<dl class="simple">
<dt><em>req</em></dt><dd><p>The request object. When Varnish has received the request the <cite>req</cite> object is
created and populated. Most of the work you do in <cite>vcl_recv</cite> you
do on or with the <cite>req</cite> object.</p>
</dd>
<dt><em>bereq</em></dt><dd><p>The backend request object. Varnish constructs this before sending it to the
backend. It is based on the <cite>req</cite> object.</p>
</dd>
</dl>
<dl class="simple">
<dt><em>beresp</em></dt><dd><p>The backend response object. It contains the headers of the object
coming from the backend. If you want to modify the response coming from the
server you modify this object in <cite>vcl_backend_response</cite>.</p>
</dd>
<dt><em>resp</em></dt><dd><p>The HTTP response right before it is delivered to the client. It is
typically modified in <cite>vcl_deliver</cite>.</p>
</dd>
<dt><em>obj</em></dt><dd><p>The object as it is stored in cache. Read only.</p>
</dd>
</dl>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="vcl-built-in-subs.html"
                        title="previous chapter">Built in subroutines</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="vcl-actions.html"
                        title="next chapter">actions</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/users-guide/vcl-variables.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="vcl-actions.html" title="actions"
             >next</a> |</li>
        <li class="right" >
          <a href="vcl-built-in-subs.html" title="Built in subroutines"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" >VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Request and response VCL objects</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>